// This file is automatically generated by Make.bash.
// Any changes made to this file will be lost.
package cynosurex.library.TetherProxLibrary;
import cynosurex.application.TetherProx.R;

import android.util.Log;

import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.concurrent.*;

public class SupermindProxyServer {
  private static final int SOCKET_TIMEOUT = 20000;
  private int port;
  private boolean acceptingRequests = false;
  ExecutorService threadPool;
  String userAgent = "unknown";

  public static void main(String[] args) throws IOException {
    SupermindProxyServer p = new SupermindProxyServer(6789);
  }

  public SupermindProxyServer(int port) {
    this.port = port;
  }

  public void start() throws IOException {
    acceptingRequests = true;
    threadPool = Executors.newCachedThreadPool();
    Thread t = new Thread(new Runnable() {
      public void run() {
        while (acceptingRequests) {
          try {
            final ServerSocket ss = new ServerSocket(port);
            while (acceptingRequests) {
              Socket s = ss.accept();
              threadPool.submit(new RequestHandler(s));
            }
          }
          catch (Throwable e) {
            e.printStackTrace();
            Log.e("Proxoid", "Restarting socket.", e);
          }
        }
      }
    });
    t.start();
  }

  public void stop() {
    acceptingRequests = false;
    threadPool.shutdownNow();
    threadPool = null;
  }

  public void setPort(int port) {
    this.port = port;
  }

  public int getPort() {
    return port;
  }

  public void setUserAgent(String userAgent) {
    this.userAgent = userAgent;
  }

  public boolean isRunning() {
    return acceptingRequests;
  }

  class RequestHandler implements Runnable {
    Client client = null;
    Socket socket = null;
    Request request = null;
    Reply reply = null;
    HttpRelay http = null;
    int currentLength = -1;
    int contentLength = -1;
    long idle = 0;

    RequestHandler(Socket socket) {
      this.socket = socket;
    }

    public void run() {
      boolean keepAlive = false;
      Exception reason = null;

      Thread.currentThread().setName("Handler("
          + socket.getInetAddress().getHostAddress()
          + ")");

      try {
        client = new Client(socket);
        client.setTimeout(SOCKET_TIMEOUT);
      }
      catch (IOException e) {
        e.printStackTrace();
        return;
      }

      try {
        do {
          request = null;
          reply = null;
          idle = System.currentTimeMillis();

          try {
            request = client.read();
          }
          catch (IOException e) {
            e.printStackTrace();
            break;
          }
          idle = 0;

          try {
            keepAlive = processRequest();
          }
          catch (IOException ioe) {
            reason = ioe;
            keepAlive = false;
            ioe.printStackTrace();
          }

          if (request != null && reply != null) {
            // XXX insert the number of bytes read into the
            // reply content-length for logging.
            if (reply != null && currentLength > 0) {
              reply.setHeaderField("Content-length", currentLength);
            }

          }
        }
        while (keepAlive);
      }
      finally {
      }

      if (reason != null && reason.getMessage().indexOf("Broken pipe") == -1) {
        if (client != null && request != null) {
          error(client.getOutputStream(), reason, request);
        }

        // don't print filter exceptions
        reason.printStackTrace();
      }

      close();
    }

    boolean processRequest() throws IOException {
      boolean keepAlive = false;

      while (reply == null) {
        boolean secure = false;

        if (request.getCommand().equals("CONNECT")) {
          secure = true;
        } else if (request.getURL().startsWith("https://")) {
          System.out.println("Netscape keep-alive bug: " + request.getURL());
          return false;
        } else if (!request.getURL().startsWith("http://")) {
          System.out.println("Unknown URL: " + request.getURL());
          return false;
        }

        /* Client wants Keep-Alive */
//        if (options.getBoolean("muffin.proxyKeepAlive")) {
//          keepAlive = (request.containsHeaderField("Proxy-Connection")
//              && request.getHeaderField("Proxy-Connection").equals("Keep-Alive"));
//        }

        /* Filter the request. */
//        if (!options.getBoolean("muffin.passthru")) {
//          /* Redirect the request if necessary */
//          String location = redirect(request);
//          if (location != null) {
//            Reply r = Reply.createRedirect(location);
//            client.write(r);
//            return keepAlive;
//          }
//
//          filter(request);
//        }

        // change useragent
        if (userAgent.equals("remove")) {
          request.removeHeaderField(userAgent);
        } else if (userAgent.equals("replace")) {
          request.setHeaderField("User-Agent", "unknown");
        } else {
//          request.setHeaderField("User-Agent", userAgent);
        }

        /* First look for any HttpFilters */
//        http = createHttpFilter(request);
        if (http == null) {
          /* None found.  Use http or https relay. */
          if (secure) {
            http = new Https(request.getHost(), request.getPort());
          } else {
            http = new Http(request.getHost(), request.getPort(), false);
          }
        }

        try {
          http.sendRequest(request);
          if (http instanceof Http) {
            ((Http) http).setTimeout(SOCKET_TIMEOUT);
          }
          reply = http.recvReply(request);
        }
        catch (RetryRequestException e) {
          http.close();
          http = null;
          continue; /* XXX */
        }

        /* Guess content-type if there aren't any headers.
              Probably an upgraded HTTP/0.9 reply. */
        if (reply.headerCount() == 0) {
          String url = request.getURL();
          if (url.endsWith("/")
              || url.endsWith(".html") || url.endsWith(".htm")) {
            reply.setHeaderField("Content-type", "text/html");
          }
        }

        /* update reply */
//        monitor.update(this);

        /* Filter the reply. */
//        if (!options.getBoolean("muffin.passthru")) {
//          /* uncompress gzip encoded html so it can be filtered */
//          if (!options.getBoolean("muffin.dontUncompress")
//              && "text/html".equals(reply.getHeaderField("Content-type"))) {
//            String encoding = reply.getHeaderField("Content-Encoding");
//            if (encoding != null && encoding.indexOf("gzip") != -1) {
//              reply.removeHeaderField("Content-Encoding");
//              reply.removeHeaderField("Content-length");
//              uncompress = true;
//            }
//          }
//
//          filter(reply);
//        }

        reply.removeHeaderField("Proxy-Connection");
        if (keepAlive && reply.containsHeaderField("Content-length")) {
          reply.setHeaderField("Proxy-Connection", "Keep-Alive");
        } else {
          keepAlive = false;
        }

        currentLength = -1;
        contentLength = -1;
        try {
          contentLength = Integer.parseInt(reply.getHeaderField("Content-length"));
        }
        catch (NumberFormatException e) {
        }

        /* update content-length reply */
//        monitor.update(this);

        if (secure) {
          Https https = (Https) http;
          int timeout = request.getPort() == 22 || request.getPort() == 45000 ? 10000000 : 30000;

          client.write(reply);

          try {
            client.setTimeout(timeout);
            https.setTimeout(timeout);
            byte[] buf = new byte[8192];
            Copy cp = new Copy(client.getInputStream(), https.getOutputStream());
            threadPool.execute(cp);
            flushCopy(https.getInputStream(), client.getOutputStream(), buf);
            client.close();
          }
          catch (InterruptedIOException iioe) {
            // ignore socket timeout exceptions
          }
        } else if (reply.hasContent()) {
          try {
            processContent();
          }
          catch (IOException e) {
            if (http instanceof Http) {
              ((Http) http).reallyClose();
            } else {
              http.close();
            }
            http = null;

            client.close();
            client = null;

            throw e;
            //return false; /* XXX */
          }

          /* Document contains no data. */
          if (contentLength == 0) {
            client.close();
          }
        } else {
          client.write(reply);
        }

        http.close();
      }

      return keepAlive;
    }

    private int flushCopy(InputStream in, OutputStream out, byte[] buf) throws IOException {
      int total = 0;
      int read;
      while ((read = in.read(buf, 0, buf.length)) != -1) {
        out.write(buf, 0, read);
        out.flush();
        total += read;
      }
      return total;
    }

    void processContent() throws IOException {
      InputStream in;
      boolean chunked = false;

      if (reply.containsHeaderField("Transfer-Encoding")
          && reply.getTransferEncoding().equals("chunked")) {
        in = readChunkedTransfer(reply.getContent());
        chunked = true;
      } else {
        in = reply.getContent();
      }

      if (in == null) {
        System.out.println("No inputstream");
        return;
      }

      client.write(reply);
      copy(in, client.getOutputStream(), contentLength);
    }

    InputStream readChunkedTransfer(InputStream in) throws IOException {
      ByteArrayOutputStream chunks = new ByteArrayOutputStream(8192);
      int size = 0;

      contentLength = 0;
      while ((size = reply.getChunkSize(in)) > 0) {
        contentLength += size;
        copy(in, chunks, size);
        reply.readLine(in);
      }
      reply.getChunkedFooter(in);

      reply.removeHeaderField("Transfer-Encoding");
      reply.setHeaderField("Content-length", contentLength);

      return new ByteArrayInputStream(chunks.toByteArray());
    }


    void copy(InputStream in, OutputStream out, int length)
        throws IOException {
      if (length == 0) {
        return;
      }

      int n;
      byte buffer[] = new byte[8192];
      long start = System.currentTimeMillis();
      long now = 0, then = start;

      for (; ;) {
        n = (length > 0) ? Math.min(length, buffer.length) : buffer.length;
        n = in.read(buffer, 0, n);
        if (n < 0) {
          break;
        }

        out.write(buffer, 0, n);

        now = System.currentTimeMillis();

        // flush after 1 second
        if (now - then > 1000) {
          out.flush();
        }

        if (length != -1) {
          length -= n;
          if (length == 0) {
            break;
          }
        }

        then = now;
      }
      out.flush();
    }

    void error(OutputStream out, Exception e, Request r) {
      StringBuffer buf = new StringBuffer();
      buf.append("While trying to retrieve the URL: <a href=\"" + r.getURL() + "\">" + r.getURL() + "</a>\r\n");
      buf.append("<p>\r\nThe following error was encountered:\r\n<p>\r\n");
      buf.append("<ul><li>" + e.toString() + "</ul>\r\n");
      String s = new HttpError(400, buf.toString()).toString();
      try {
        out.write(s.getBytes(), 0, s.length());
        out.flush();
      }
      catch (Exception ex) {
      }
    }

    synchronized void close() {
      if (client != null) {
        client.close();
        client = null;
      }
      if (http != null) {
        http.close();
        http = null;
      }
    }

  }
}
